import _defineProperty from '@babel/runtime/helpers/esm/defineProperty';
import Controller from '@keystonejs/fields/Controller';

class EditorJsController extends Controller {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "getFilterGraphQL", ({
      type,
      value
    }) => {
      const key = type === 'is_i' ? `${this.path}_i` : `${this.path}_${type}`;
      return {
        [key]: value
      };
    });

    _defineProperty(this, "getFilterLabel", ({
      label
    }) => {
      return `${this.label} ${label.toLowerCase()}`;
    });

    _defineProperty(this, "serialize", data => {
      if (data[this.path]) {
        return JSON.stringify(data[this.path]);
      }

      return null;
    });

    _defineProperty(this, "deserialize", data => {
      try {
        return JSON.parse(data[this.path]);
      } catch (error) {
        return {};
      }
    });

    _defineProperty(this, "formatFilter", ({
      label,
      value
    }) => {
      return `${this.getFilterLabel({
        label
      })}: "${value}"`;
    });

    _defineProperty(this, "getFilterTypes", () => [{
      type: 'contains_i',
      label: 'Contains',
      getInitialValue: () => ''
    }, {
      type: 'not_contains_i',
      label: 'Does not contain',
      getInitialValue: () => ''
    }]);
  }

}

export default EditorJsController;
